#!/bin/bash

##################################################################
##								##
##	Simple script to clean up mailboxes server-side		##
##	     for SME Server (http://contribs.org/)              ##
##	 > To enhance IMAP and MS Outlook integration		##
##								##
##     Created by Tim Birkett: (tim@yourproblemsolved.com)	##
##								##
##     Licensed under GNU GPL v3 or later, at your option.	##
##	      http://www.gnu.org/licenses/gpl.htm               ##
##								##
##	  		  INSTRUCTIONS:-			##
##            ENSURE EACH USER HAS A TRASH FOLDER               ##
##	 Place this script somewhere like "/opt/scripts/"       ##
##  then run in a screen: "screen -m -d /opt/scripts/trash.sh"  ##
##	    add to "/etc/rc.local" to start on reboot.		##
##								##
##################################################################

INTERVAL=3
while true
do
	## get a list of files marked for deletion by MS Outlook (replacing spaces with _)
	Array1=($(find /home/e-smith/files/users/*/Maildir/ -type f -name "*T*" | tr ' ' '£' | tr '\n' ' '))
	sleep $INTERVAL
	Array2=($(find /home/e-smith/files/users/*/Maildir/ -type f -name "*T*" | tr ' ' '£' | tr '\n' ' '))
	oldIFS=$IFS 
	IFS=$'\n\t'
	Array3=($(comm -1 <(echo ${Array1[*]}) <(echo ${Array2[*]})))
	IFS=$oldIFS
	for MSG in ${Array3[@]}
	do
		filepath=${MSG%/Maildir/*}
		filename=${MSG##*/}
		newfilename=${filename//T/}
		moveto="$filepath/Maildir/.Trash/cur/$newfilename"
		MSG=$(echo $MSG | sed 's/£/\ /g')
		mv "$MSG" "$moveto"	
	done	
	Array1=()
	Array2=()
	Array3=()
done

